//  -*- Mode: C++; -*-

// Copyright (c) 1993 Siemens Corporate Research, Inc.
// All rights reserved.
//
// $Author: bnell $
// $Date: 1996/12/18 15:46:18 $
// $Source: /home/yugo/kwuftn/CVS-repository/scheme-interface/scheme_vec.c,v $
// $Revision: 1.2 $
//

#ifndef __GNUG__
#include "scheme_vec.h"
#endif

template <class T>
SCM scheme_vec<T>::to_scheme()
{
  SCM vec = scheme::make_vector(_len);
  for(unsigned int i = 0; i < _len; i++)
    scheme::vset(vec, i, scmify((value()[i])));
  return vec;
}

template <class T>
scheme_vec<T>::scheme_vec()
: schemet<T*>((T*)0), _len(0), _nodel(0)
{
}

template <class T>
scheme_vec<T>::scheme_vec(T* vec, unsigned int len)
: schemet<T*>(vec), _len(len), _nodel(1)
{
}

template <class T>
scheme_vec<T>::scheme_vec(const scheme_vec<T>& vec)
: schemet<T*>(new T[vec._len]), _len(vec._len), _nodel(0)
{
  for(unsigned int i = 0; i < _len; i++)
    value()[i] = vec.value()[i];
}

template <class T>
scheme_vec<T>::scheme_vec(T* val)
: schemet<T*>(val), _nodel(1)
{
}

template <class T>
scheme_vec<T>::scheme_vec(SCM s)
: schemet<T*>(new T[scheme::obj_length(s)]), _len(scheme::obj_length(s)),
  _nodel(0)
{
  for(unsigned int i = 0; i < _len; i++)
    value()[i] = scheme_convert(scheme::vref(s, i), (T*)0);
}

template <class T>
scheme_vec<T>::~scheme_vec()
{
  if(!_nodel)
    delete[] value();
}
