//  -*- Mode: C++; -*-

// Copyright (c) 1993 Siemens Corporate Research, Inc.
// All rights reserved.
//
// $Author: bnell $
// $Date: 1996/12/18 15:46:19 $
// $Source: /home/yugo/kwuftn/CVS-repository/scheme-interface/scheme_vec.h,v $
// $Revision: 1.2 $
//

#ifndef _SCHEME_VEC_H_
#define _SCHEME_VEC_H_

#include "scheme-types.h"

template <class T> class scheme_vec : public schemet<T*> {
 public:
  SCM to_scheme();
  T& operator[](unsigned int i) { return value()[i]; }
  unsigned int length() const { return _len; }
  scheme_vec();
  scheme_vec(const scheme_vec<T>& vec);
  scheme_vec(T* vec, unsigned int len);
  scheme_vec(SCM s);
  ~scheme_vec();
 protected:
  scheme_vec(T* val);
  void set_length(unsigned int l) { _len = l; }
 private:
  unsigned int _len;
  int _nodel;
};

#ifdef __GNUG__
#include "scheme_vec.c"
#endif

#endif
