//  -*- Mode: C++; -*-

// Copyright (c) 1993 Siemens Corporate Research, Inc.
// All rights reserved.
//
// $Author: bnell $
// $Date: 1996/12/18 15:46:22 $
// $Source: /home/yugo/kwuftn/CVS-repository/scheme-interface/template.cc,v $
// $Revision: 1.2 $
//

#include <iostream.h>
#include "scheme-types.h"

#define NIL(n)
#define CLASS(n) class
#define NOSEP()
#define COMMA() ,
#define COMMA1(n) ,
#define SEMI() ;
#define SCM_CNV(n) SA##n arg##n =

#define REP0(b, v, a, sep)
#define REP1(b, v, a, sep) b(1) v##1 a(1)
#define REP2(b, v, a, sep) REP1(b,v,a,sep) sep() b(2) v##2 a(2)
#define REP3(b, v, a, sep) REP2(b,v,a,sep) sep() b(3) v##3 a(3)
#define REP4(b, v, a, sep) REP3(b,v,a,sep) sep() b(4) v##4 a(4)
#define REP5(b, v, a, sep) REP4(b,v,a,sep) sep() b(5) v##5 a(5)
#define REP6(b, v, a, sep) REP5(b,v,a,sep) sep() b(6) v##6 a(6)
#define REP7(b, v, a, sep) REP6(b,v,a,sep) sep() b(7) v##7 a(7)
#define REP8(b, v, a, sep) REP7(b,v,a,sep) sep() b(8) v##8 a(8)
#define REP9(b, v, a, sep) REP8(b,v,a,sep) sep() b(9) v##9 a(9)

#define SCHEME_FUNC(n)\
template <class R, REP##n(CLASS,A,COMMA1,NOSEP) class SR, REP##n(CLASS,SA,COMMA1,NOSEP) R (*f)(REP##n(NIL,A,NIL,COMMA))> class scheme_func_##n {\
 public:\
  static SCM call(REP##n(NIL,SCM _arg,NIL,COMMA))\
  {\
    scheme_save_stack ss;\
    {\
      REP##n(SCM_CNV,_arg,NIL,SEMI);\
      SR ret = f(REP##n(NIL,arg,NIL,COMMA));\
      return ret;\
    }\
  }\
  scheme_func_##n() { } \
  scheme_func_##n(const char* name) { scheme::define_func((SCMfn)call, name, n, 0, 0); } \
}

#define SCHEME_METHOD(n)\
template <class C, class R, REP##n(CLASS,A,COMMA1,NOSEP) class SR, REP##n(CLASS,SA,COMMA1,NOSEP) R (C::*m)(REP##n(NIL,A,NIL,COMMA))> class scheme_method_##n {\
 public:\
  static SCM call(SCM _obj REP##n(COMMA1,SCM _arg,NIL,NOSEP))\
  {\
    scheme_save_stack ss;\
    {\
      scheme_ptr<C> obj = _obj;\
      REP##n(SCM_CNV,_arg,NIL,SEMI);\
      SR ret = (obj->*m)(REP##n(NIL,arg,NIL,COMMA));\
      return ret;\
    }\
  }\
  scheme_method_##n() { } \
  scheme_method_##n(const char* name) { scheme::define_func((SCMfn)call, name, n, 0, 0); } \
}

SCHEME_FUNC(0);
SCHEME_FUNC(1);
SCHEME_FUNC(2);
SCHEME_FUNC(3);
SCHEME_FUNC(4);
SCHEME_FUNC(5);
SCHEME_FUNC(6);
SCHEME_FUNC(7);
SCHEME_FUNC(8);
SCHEME_FUNC(9);

SCHEME_METHOD(0);
SCHEME_METHOD(1);
SCHEME_METHOD(2);
SCHEME_METHOD(3);
SCHEME_METHOD(4);
SCHEME_METHOD(5);
SCHEME_METHOD(6);
SCHEME_METHOD(7);
SCHEME_METHOD(8);
SCHEME_METHOD(9);

int a(int x, int y) { return x + y; }
int b(int x, int y) { return x - y; }
int c()             { return 22; }

class D {
 public:
  int add(int x) { return x + _val; }
  D(int x) : _val(x) { }
 private:
  int _val;
};

int main(int argc, char* argv[])
{
  scheme::init(argc, argv);

  scheme_func_2<int, int, int, scheme_value<int>, scheme_value<int>, scheme_value<int>, a> af("af");
  scheme_func_2<int, int, int, scheme_value<int>, scheme_value<int>, scheme_value<int>, b> bf("bf");
  scheme_func_0<int, scheme_value<int>, c> cf("cf");

  // compilers still too stupid for this
  //  scheme_method_1<D, int, int, scheme_value<int>, scheme_value<int>, D::add> df("D:add");

  scheme_value<int> two = 2;
  SCM r1 = scheme::call("af", two, two);
  SCM r2 = scheme::call("bf", two, two);
  SCM r3 = scheme::call("cf");

  scheme_value<int> sr1 = r1;
  scheme_value<int> sr2 = r2;
  scheme_value<int> sr3 = r3;

  cout << "af: " << (int)sr1 << endl;
  cout << "bf: " << (int)sr2 << endl;
  cout << "cf: " << (int)sr3 << endl;

  return 0;
}
