/* IluBaseException.java */
/* Chris Jacobi, December 11, 1996 9:56 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

/* 
 * $Id: IluBaseException.java,v 1.4 1996/12/12 06:33:22 jacobi Exp $
 */
 
package xerox.ilu;

/**
 * IluBaseException is a handy superclass of Exception.
 * This enables us to add fields without editing each Exception class
 * @author      Chris Jacobi
 */
public
class IluBaseException extends java.lang.Exception {
    
    /** Generic constructor */
    public IluBaseException() {
	super();
    }
    
    /** Generic constructor */
    public IluBaseException(String s) {
	super(s);
    }
    
    /** 
     * Don't modify exceptions which aren't yours.
     */
    protected void setRock(Object rock) {
    	//this is overloaded when there is something to do
    }
    
} //IluBaseException
