/* IluException0.java */
/* Chris Jacobi, December 11, 1996 10:23 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluException0.java,v 1.2 1996/12/12 06:31:31 jacobi Exp $ */
 

package xerox.ilu;

/**
 * IluException0 is an artificial superclass of IluException.
 * - Clients can use this to catch all ilu exceptions.
 * - Clients must not throw this exceptions. 
 * - Clients must not declare methods to throw this exceptions. 
 *
 * @author      Chris Jacobi
 */
public abstract
class IluException0 extends xerox.ilu.IluBaseException {
    
    public IluException0() {
	super();
    }
    
    public IluException0(String s) {
	super(s);
    }
    
    protected int theExceptionType = 0;
    protected java.lang.String theExceptionId = null;
    
    //accessor required by corba Exception
    public int exceptionType() {
	return theExceptionType;
    }

    //accessor required by corba Exception
    public java.lang.String exceptionId() {
	return theExceptionId;
    }
    
} // IluException0
