/* IluInit.java */
/* Chris Jacobi, July 25, 1996 11:10 am PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluInit.java,v 1.4 1996/07/25 18:11:26 jacobi Exp $ */
 
/*
 * See IluInit2.java
 */


package xerox.ilu;

/** 
 * Helper class which takes care of initialization of ILU.
 *
 * Initialization is deferred throw dynamic invokation of the loader
 * to break dependency circles.  There are no deep reason except
 * the speed up and frequency of recompilations.
 */
 
public class IluInit {
    
    /* Flag to speed up recursive initializations */
    private static boolean initialized = false;
    
    /** Initialization procedures.  Idempotent */
    public static final void init () {
        if ( ! initialized) {
            java.lang.Class clazz;
            try {
                clazz = java.lang.Class.forName("xerox.ilu.IluInit2");
                initialized = true;
            } catch (java.lang.ClassNotFoundException e) {
                System.err.println("** failed initializing Ilu" + e);
            }
        }
    }
    
    static {
        init();
    }

} // IluInit