/* IluJava_CJ.h */
/* Chris Jacobi, July 3, 1996 12:18 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluJava_CJ.h,v 1.1 1996/07/12 00:38:31 jacobi Exp $ */

/*
 * Macros for C <-> Java interoperability
 */

#ifndef _ILUJAVA_CJ_
#define _ILUJAVA_CJ_

#include <interpreter.h>
/* include generic Java stuff; in particular the macro "unhand" */


/* Accessing C pointers from Java objects:
 * Java does not have a type for representation of C pointers.
 * We use the Java type "long" (which uses 64 bits) to represent C
 * pointers, in anticipation of architectures which require so...
 */
 
 
#define Access(obj, field, type) ( * (type *) &(unhand(obj) -> field ) )
/*
 * Accesses a field of a Java object [handle] 
 * obj: Java object
 * field: name of the field (actually the same in Jva and in C)
 * type: real type of the field (as seen from C)
 *
 * Can be used on left or right side of assignments
 * Don't remove the spaces; the C macro processor is unforgiving
 */


#define Access0(ptr, field, type) ( * (type *) &(ptr -> field ) )
/*
 * Accesses a field of a Java object record 
 * ptr: Pointer to Java record
 * field: name of the field (actually the same in Jva and in C)
 * type: real type of the field (as seen from C)
 *
 * Can be used on left or right side of assignments
 * Don't remove the spaces; the C macro processor is unforgiving
 */
 
 
#endif /* _ILUJAVA_CJ_ */
