/* IluJava_GCClient.c */
/* Chris Jacobi, January 16, 1997 12:39 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluJava_GCClient.c,v 1.5 1997/01/16 20:48:19 jacobi Exp $ */
 
/*
 * C side for GCClient.java
 */

 
#include <StubPreamble.h>
#include <interpreter.h>

#include <iluxport.h>
#include <iluerror.h>
#include "IluJava.h"
#include "IluJava_JStubs.h"
#include "xerox_ilu_IluGCClient.h"


EXPORTJAVA long
xerox_ilu_IluGCClient_nativeIsGcClientSet(
	struct Hxerox_ilu_IluGCClient * unused) 
{
    long isSet = 0;
    if (ilu_IsGcClientSet()) isSet = 1; 
    return isSet;
}


EXPORTJAVA void
xerox_ilu_IluGCClient_finishSpecialGCClass(
	struct Hxerox_ilu_IluGCClient * unused,
	struct Hxerox_ilu_IluClassRep * jClass) 
{
    ilu_Class cClass = ilu_GetGcCallbackClass();
    Access(jClass, yIluClass, ilu_Class) = cClass;
    if (_ilujava_definitionsFlag>0) {
        ilu_DebugPrintf("$ GCClient: jClass=<%x>, cClass=<%x>\n", jClass, cClass);
    }
}


EXPORTJAVA void
xerox_ilu_IluGCClient_setupSpecialGCObj(
	struct Hxerox_ilu_IluGCClient * unused,
	struct Hxerox_ilu_IluOInt * joi) 
{
    ilu_Object cGCObj = Access(joi, yIluKernelObject, ilu_Object);
    if (_ilujava_definitionsFlag>0) {
        ilu_DebugPrintf("$ GCClient: cGCObj =<%x>\n", cGCObj);
    }
    ilu_SetGcClient(cGCObj);
}


