/* IluJava_IluExceptionRep.c */
/* Chris Jacobi, July 3, 1996 12:30 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluJava_IluExceptionRep.c,v 1.1 1996/07/12 00:40:57 jacobi Exp $ */
 
/*
 * C side of IluExceptionRep.java
 */


#include <StubPreamble.h>
#include <interpreter.h>
#include <javaString.h>
#include "xerox_ilu_IluExceptionRep.h"

#include <iluxport.h>
#include <iluerror.h>
#include "IluJava.h"


IMPORTVAR char * _iluJava_notUsed1;
IMPORTVAR char * _iluJava_notUsed2; 


EXPORTJAVA void 
xerox_ilu_IluExceptionRep_registerException(
		struct Hxerox_ilu_IluExceptionRep * jobj)
{
    ilu_Exception cIluException;
    ilu_Error	err = ILU_INIT_NO_ERR;
    /* 
     * (javaString.h)makeCString converts unicode to char's 
     * and returns a garbage collectable C string
     * (ilu_DefineException says: caller owns data) 
     */
    char * i = makeCString(unhand(jobj)->i); /*javaString.h*/
    char * e = makeCString(unhand(jobj)->e); 
    cIluException = ilu_DefineException(i, e, &err);
    ILU_MUST_BE_SUCCESS(err);
    Access(jobj, yIluException, ilu_Exception) = cIluException;
    /* make sure pointers are around and not garbage collected to early */
    _iluJava_notUsed1 = i;
    _iluJava_notUsed2 = e;
}
