/* IluJava_IluPassport.c */
/* Chris Jacobi, July 3, 1996 5:13 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* 
 * $Id: IluJava_IluPassport.c,v 1.1 1996/07/12 00:41:31 jacobi Exp $ 
 *
 *
 * C side of IluPassport.java
 */

 
#include "IluJava.h"
#include "xerox_ilu_IluPassport.h"


static ilu_Passport _ilujava_defaultPassport;


EXPORTLIMITED void
_ilujava_PassportInit()
{
    ilu_Error err = ILU_INIT_NO_ERR;
    _ilujava_defaultPassport = ilu_CreatePassport(0, &err);
}


EXPORTLIMITED ilu_Passport 
_iluJava_getIluPassport(
	ilu_refany jIluPassport /* struct Hxerox_ilu_IluPassport* */ 
	)
/* Converts java passport to ilu passport.
 * Converts null IluPassport into default passport. 
 */
 {
     ilu_Passport cpp = 0;
     struct Hxerox_ilu_IluPassport* jp 
     	= (struct Hxerox_ilu_IluPassport*) jIluPassport;
     if (jp==0) return _ilujava_defaultPassport;
     cpp = Access(jp, yIluPassport, ilu_Passport);
     if (cpp==0) return _ilujava_defaultPassport;
     return cpp;
 }
