/* IluObjectBase.java */
/* Chris Jacobi, January 3, 1997 2:17 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id $ */
 

package xerox.ilu;

/**
 * Base super class for surrogate object implementation.<p>
 * Class is client visible.
 * Class might be used as base class for true objects, at the
 * discretion of the programmer (of the true object's class).
 */
public abstract class IluObjectBase implements IluObject, IluAnchorSupport {
    protected IluOInt oint = null; 
    protected IluObjectBase() {
    }
    /** This is logically "friendly" but public to 
     * export the IluAnchorSupport interface
     */
    public void rememberAnchor(Object internal) {
        //Ilu calls this only once
        if (oint==null) oint = (IluOInt) internal;
    }
    /* Not public but for surrogate stubs 
     * Surrogates DO have IluAnchorSupport, others may crash...
     */
    public IluClassRep getIluClass() {
        return oint.jClassRep;
    }
} //IluObjectBase
