/* ObjectMethods.java */
/* Chris Jacobi, November 26, 1996 1:02 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */ 
 
/*
 * ObjectMethods.java
 * Static implementation of corba object methods   
 *
 * $Id: ObjectMethods.java,v 1.3 1996/12/03 03:50:14 jacobi Exp $
 */
 
package xerox.ilu;

public class ObjectMethods {

    public static boolean isA(xerox.ilu.IluObject0 obj, xerox.ilu.IluClassRep iluclass) {
        if (obj==null) throw new java.lang.NullPointerException(); 
        if (iluclass==null) throw new java.lang.NullPointerException(); 
        xerox.ilu.IluOInt oi = xerox.ilu.IluOInt.peek((xerox.ilu.IluObject)obj);
        if (oi==null) return false;
        while (iluclass!=null) {
            if (iluclass==oi.jClassRep) return true;
            iluclass = iluclass.superClass();
        }
        return false;
    }
    
    public static boolean isA(xerox.ilu.IluObject0 obj, String typeId) {
        // I HAVE NO IDEA HOW TO IMPLEMENT THIS
        // Is the typid repository Id equal to the class name ?? 
        // What if typeId is more specific then the mstid of obj known to java ?
        return false;
    }
    
    public static xerox.ilu.IluObject duplicate(xerox.ilu.IluObject0 obj) {
        if (obj==null) throw new java.lang.NullPointerException(); 
        return (xerox.ilu.IluObject) obj;
        // Another Orb implementation might keep a ref count in IluOInt etc.
    }
    
    public static void release(xerox.ilu.IluObject0 obj) {
    }

} //ObjectMethods
