/* omg.corba.corba_Exception.java */
/* Chris Jacobi, December 11, 1996 10:23 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: corba_Exception.java,v 1.3 1996/12/12 06:31:39 jacobi Exp $ */
 

package omg.corba;

/**
 * omg.corba.corba_Exception represents corba exceptions in
 * a limited way:
 * - Clients can use this to catch all corba exceptions.
 * - Clients may declare methods to throw this exceptions. 
 * - Clients must NOT throw this exceptions. 
 *
 * @author      Chris Jacobi
 */ 
public abstract 
class corba_Exception extends xerox.ilu.IluException0 {
    public corba_Exception() {
	super();
    }
    public corba_Exception(String s) {
	super(s);
    }
    
    // corba defined exception types.
    static public final int noException = 0;
    static public final int userException = 1;
    static public final int systemException = 2;
    
    //The static required accessors are inherited 

}
