/* omg.corba.corba_RuntimeException.java */
/* Chris Jacobi, November 27, 1996 12:13 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

 
/*
 * omg.corba.corba_RuntimeException.java
 * - applications may catch this exception 
 * - applications may not throw this exception  
 * - applications may not make direct sub-classes
 * (Ilu excpects to knows all sub classes)  
 *
 * @author Chris Jacobi
 * @see xerox.basics.ChainedError
 */
 
/*
 * $Id: corba_RuntimeException.java,v 1.2 1996/11/27 20:25:05 jacobi Exp $
 */

package omg.corba;

abstract public 
class corba_RuntimeException extends RuntimeException {
    public Throwable causedBy = null;

    protected corba_RuntimeException() {
	this("corba_RuntimeException");
    }
    protected corba_RuntimeException(String id) {
	super(id);
    }

    public void setCause(Throwable causedBy) {
        this.causedBy = causedBy;
    }
    
    public corba_RuntimeException(String s, Throwable causedBy) {
	super(s);
	setCause(causedBy);
    }

} //corba_RuntimeException
 

