//  -*- Mode: C++; -*-

// Copyright (c) 1996 Siemens Corporation.  All Rights Reserved.  
//
// Unlimited use, reproduction, and distribution of this software is
// permitted.  Any copy of this software must include both the above
// copyright notice of Siemens Corporation and this paragraph.  Any
// distribution of this software must comply with all applicable United
// States export control laws.  This software is made available AS IS,
// and SIEMENS CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
// INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
// PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
// THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
// CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
// SIEMENS CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// $Author: bnell $
// $Date: 1996/11/13 16:57:26 $
// $Source: /home/yugo/kwuftn/CVS-repository/ilu-scheme-runtime/ilu-scm-init.cc,v $
// $Revision: 1.2 $
//

#include <iostream.h>
#include <stdlib.h>
#include "ilu-type.h"
#include "iluobj-scm.h"
#include "ilusrvr-scm.h"
#include "ilu-scm-private.h"

static void ilu_init()
{
  // from ilu-scm.cc
  scheme_define_func(ilu__scheme_lang_idx, 0, 0, 0);
  scheme_define_func(ilu__full_prefer_success, 3, 0, 0);
  scheme_define_func(ilu__enter_ot_mu, 0, 0, 0);
  scheme_define_func(ilu__exit_ot_mu, 0, 0, 0);
  scheme_define_func(ilu__object_type_defined, 1, 0, 0);
  scheme_define_func(ilu__define_exception, 2, 0, 0);
  scheme_define_func(ilu__define_object_type, 10, 0, 0);
  scheme_define_func(ilu__define_method, 8, 0, 0);
  scheme_define_func(ilu__start_call, 4, 0, 0);
  scheme_define_func(ilu__begin_sizing_exception, 2, 0, 0);
  scheme_define_func(ilu__begin_exception, 3, 0, 0);
  scheme_define_func(ilu__start_request, 2, 0, 0);
  scheme_define_func(ilu__begin_sizing_reply, 2, 0, 0);
  scheme_define_func(ilu__begin_reply, 3, 0, 0);
  scheme_define_func(ilu__end_sequence, 1, 0, 0);
  scheme_define_func(ilu__end_union, 1, 0, 0);
  scheme_define_func(ilu__end_record, 1, 0, 0);
  scheme_define_func(ilu__end_array, 1, 0, 0);
  scheme_define_func(ilu__exception_of_method, 2, 0, 0);
  scheme_define_func(ilu__exception_count_of_method, 1, 0, 0);
  scheme_define_func(ilu__get_object_class, 1, 0, 0);
  scheme_define_func(ilu__get_object_server, 1, 0, 0);
  scheme_define_func(ilu__reply_read, 1, 0, 0);
  scheme_define_func(ilu__finish_call, 1, 0, 0);
  scheme_define_func(ilu__finish_exception, 1, 0, 0);
  scheme_define_func(ilu__finish_request, 1, 0, 0);
  scheme_define_func(ilu__finish_reply, 1, 0, 0);
  scheme_define_func(ilu__no_reply, 1, 0, 0);
  scheme_define_func(ilu__finish_parameters, 2, 0, 0);
  scheme_define_func(ilu__input_byte, 1, 0, 0);
  scheme_define_func(ilu__input_boolean, 1, 0, 0);
  scheme_define_func(ilu__input_optional, 1, 0, 0);
  scheme_define_func(ilu__input_cardinal, 1, 0, 0);
  scheme_define_func(ilu__input_character, 1, 0, 0);
  scheme_define_func(ilu__input_enum, 1, 0, 0);
  scheme_define_func(ilu__input_integer, 1, 0, 0);
  scheme_define_func(ilu__input_real, 1, 0, 0);
  scheme_define_func(ilu__input_short_cardinal, 1, 0, 0);
  scheme_define_func(ilu__input_short_integer, 1, 0, 0);
  scheme_define_func(ilu__input_short_real, 1, 0, 0);
  scheme_define_func(ilu__input_long_cardinal, 1, 0, 0);
  scheme_define_func(ilu__input_long_integer, 1, 0, 0);
  scheme_define_func(ilu__input_long_real, 1, 0, 0);
  scheme_define_func(ilu__input_bytes, 2, 0, 0);
  scheme_define_func(ilu__input_opaque, 2, 0, 0);
  scheme_define_func(ilu__input_string, 2, 0, 0);
  scheme_define_func(ilu__input_string_vec, 2, 0, 0);
  scheme_define_func(ilu__input_w_string, 2, 0, 0);
  scheme_define_func(ilu__input_w_string_vec, 2, 0, 0);
  scheme_define_func(ilu__input_object_id, 3, 0, 0);
  scheme_define_func(ilu__input_sequence, 2, 0, 0);
  scheme_define_func(ilu__input_union, 2, 0, 0);
  scheme_define_func(ilu__input_record, 1, 0, 0);
  scheme_define_func(ilu__input_array, 1, 0, 0);
  scheme_define_func(ilu__enter_server, 2, 0, 0);
  scheme_define_func(ilu__exit_server, 2, 0, 0);
  scheme_define_func(ilu__sbh_to_object, 2, 0, 0);
  scheme_define_func(ilu__sbh_of_object, 1, 0, 0);
  scheme_define_func(ilu__output_byte, 2, 0, 0);
  scheme_define_func(ilu__output_boolean, 2, 0, 0);
  scheme_define_func(ilu__output_optional, 2, 0, 0);
  scheme_define_func(ilu__output_cardinal, 2, 0, 0);
  scheme_define_func(ilu__output_character, 2, 0, 0);
  scheme_define_func(ilu__output_enum, 2, 0, 0);
  scheme_define_func(ilu__output_integer, 2, 0, 0);
  scheme_define_func(ilu__output_real, 2, 0, 0);
  scheme_define_func(ilu__output_short_integer, 2, 0, 0);
  scheme_define_func(ilu__output_short_real, 2, 0, 0);
  scheme_define_func(ilu__output_long_cardinal, 2, 0, 0);
  scheme_define_func(ilu__output_long_integer, 2, 0, 0);
  scheme_define_func(ilu__output_long_real, 2, 0, 0);
  scheme_define_func(ilu__output_bytes, 4, 0, 0);
  scheme_define_func(ilu__output_opaque, 3, 0, 0);
  scheme_define_func(ilu__output_string, 4, 0, 0);
  scheme_define_func(ilu__output_string_vec, 3, 0, 0);
  scheme_define_func(ilu__output_w_string, 4, 0, 0);
  scheme_define_func(ilu__output_w_string_vec, 3, 0, 0);
  scheme_define_func(ilu__output_object_id, 4, 0, 0);
  scheme_define_func(ilu__output_sequence, 3, 0, 0);
  scheme_define_func(ilu__output_union, 3, 0, 0);
  scheme_define_func(ilu__output_array, 1, 0, 0);
  scheme_define_func(ilu__output_record, 1, 0, 0);
  scheme_define_func(ilu__size_of_byte, 2, 0, 0);
  scheme_define_func(ilu__size_of_boolean, 2, 0, 0);
  scheme_define_func(ilu__size_of_optional, 2, 0, 0);
  scheme_define_func(ilu__size_of_cardinal, 2, 0, 0);
  scheme_define_func(ilu__size_of_character, 2, 0, 0);
  scheme_define_func(ilu__size_of_enum, 2, 0, 0);
  scheme_define_func(ilu__size_of_integer, 2, 0, 0);
  scheme_define_func(ilu__size_of_real, 2, 0, 0);
  scheme_define_func(ilu__size_of_short_cardinal, 2, 0, 0);
  scheme_define_func(ilu__size_of_short_integer, 2, 0, 0);
  scheme_define_func(ilu__size_of_short_real, 2, 0, 0);
  scheme_define_func(ilu__size_of_long_cardinal, 2, 0, 0);
  scheme_define_func(ilu__size_of_long_integer, 2, 0, 0);
  scheme_define_func(ilu__size_of_long_real, 2, 0, 0);
  scheme_define_func(ilu__size_of_bytes, 4, 0, 0);
  scheme_define_func(ilu__size_of_opaque, 3, 0, 0);
  scheme_define_func(ilu__size_of_string, 4, 0, 0);
  scheme_define_func(ilu__size_of_string_vec, 3, 0, 0);
  scheme_define_func(ilu__size_of_w_string, 4, 0, 0);
  scheme_define_func(ilu__size_of_w_string_vec, 3, 0, 0);
  scheme_define_func(ilu__size_of_object_id, 4, 0, 0);
  scheme_define_func(ilu__size_of_sequence, 3, 0, 0);
  scheme_define_func(ilu__size_of_union, 3, 0, 0);
  scheme_define_func(ilu__size_of_array, 1, 0, 0);
  scheme_define_func(ilu__size_of_record, 1, 0, 0);
  scheme_define_func(ilu__wait_for_reply, 1, 0, 0);
  scheme_define_func(ilu__set_default_server, 1, 0, 0);
  scheme_define_func(ilu__get_default_server, 0, 0, 0);
  scheme_define_func(ilu__create_port, 3, 0, 0);
  scheme_define_func(ilu__set_server_default_port, 2, 0, 0);
  scheme_define_func(ilu__parse_sbh, 1, 0, 0);
  scheme_define_func(ilu__receive_request, 1, 0, 0);
  scheme_define_func(ilu__handle_new_connection, 1, 0, 0);
  scheme_define_func(ilu__close_connection, 1, 0, 0);
  scheme_define_func(ilu__wait_for_port_connection_request, 1, 0, 0);
  scheme_define_func(ilu__create_true_kernel_object, 4, 0, 0);
  scheme_define_func(ilu__find_class_from_type_name, 1, 0, 0);
  scheme_define_func(ilu__find_class_from_id, 1, 0, 0);
  scheme_define_func(ilu__get_language_specific_object, 1, 0, 0);
  scheme_define_func(ilu__set_language_specific_object, 2, 0, 0);
  scheme_define_func(ilu__run_main_loop, 1, 0, 0);
  scheme_define_func(ilu__exit_main_loop, 1, 0, 0);
  scheme_define_func(ilu__register_input_handler, 2, 0, 0);
  scheme_define_func(ilu__unregister_input_handler, 1, 0, 0);
  scheme_define_func(ilu__register_output_handler, 2, 0, 0);
  scheme_define_func(ilu__unregister_output_handler, 1, 0, 0);
  scheme_define_func(ilu__publish_object, 1, 0, 0);
  scheme_define_func(ilu__withdraw_object, 2, 0, 0);
  scheme_define_func(ilu__server_of_object, 1, 0, 0);
  scheme_define_func(ilu__set_main_loop, 1, 0, 0);
  scheme_define_func(ilu__create_alarm, 0, 0, 0);
  scheme_define_func(ilu__set_alarm, 3, 0, 0);
  scheme_define_func(ilu__clear_alarm, 1, 0, 0);
  scheme_define_func(ilu__time_now, 0, 0, 0);
  scheme_define_func(ilu__err_nok, 1, 0, 0);
  scheme_define_func(ilu__set_method_stub_proc, 2, 0, 0);
  scheme_define_func(ilu__get_gc_callback_class, 0, 0, 0);

  // ilu call stuff
  scheme_define_func(ilu_call__create, 0, 0, 0);
  scheme_define_func(ilu_call__destroy, 1, 0, 0);
  scheme_define_func(ilu_call__caller, 1, 0, 0);
  scheme_define_func(ilu_call__protocol_exception, 1, 0, 0);
  scheme_define_func(ilu_call__error, 1, 0, 0);
  scheme_define_func(ilu_call__method_of_call, 1, 0, 0);

  // class stuff
  scheme_define_func(ilu_class__method, 2, 0, 0);
  scheme_define_func(ilu_class__name, 1, 0, 0);
  scheme_define_func(ilu_class__unique_id, 2, 0, 0);

  // from iluobj-scm.cc
  scheme_define_func(ilu_object__register_surrogate_creator, 2, 0, 0);
  scheme_define_func(ilu_object__create_from_registry, 2, 0, 0);
  scheme_define_func(ilu_object__input_object, 3, 0, 0);
  scheme_define_func(ilu_object__output_object, 3, 0, 0);
  scheme_define_func(ilu_object__size_of_object, 3, 0, 0);
  scheme_define_func(ilu_object__lookup, 3, 0, 0);
  scheme_define_func(ilu_object__register_as_gc_callback, 1, 0, 0);

  // from ilusrvr-scm.cc
  scheme_define_func(ilu_server__add_port, 4, 0, 0);
  scheme_define_func(ilu_server__create, 2, 0, 0);
  scheme_define_func(ilu_server__id, 1, 0, 0);
}

int ilu_scheme_main(int argc,
		    char* argv[],
		    void (*init)(),
		    char* scm_file,
		    char* scm_main,
		    int scm_argv)
{
  extern void init_hash_tables();
  static char buff[2048];

  /* pain in the ass hack to get require to work right... */
  if(!getenv("ILUHOME")) {
    cerr << "ILUHOME environment variable not set!" << endl;
    return -1;
  } else {
    sprintf(buff, "SCHEME_LIBRARY_PATH=%s/scheme/", getenv("ILUHOME"));
    putenv(buff);
  }

  init_hash_tables();

  int ret = scheme::init(argc, argv, ilu_init, scm_file, scm_main, scm_argv);
  if(init) init();

  return ret;
}
