//  -*- Mode: C++; -*-

// Copyright (c) 1996 Siemens Corporation.  All Rights Reserved.  
//
// Unlimited use, reproduction, and distribution of this software is
// permitted.  Any copy of this software must include both the above
// copyright notice of Siemens Corporation and this paragraph.  Any
// distribution of this software must comply with all applicable United
// States export control laws.  This software is made available AS IS,
// and SIEMENS CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
// INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
// PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
// THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
// CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
// SIEMENS CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// $Author: bnell $
// $Date: 1996/11/08 19:08:56 $
// $Source: /home/yugo/kwuftn/CVS-repository/ilu-scheme-runtime/ilu-scm-private.h,v $
// $Revision: 1.1 $
//

#ifndef _ILU_SCM_PRIVATE_H_
#define _ILU_SCM_PRIVATE_H_

#include "ilu-type.h"
#define ilu_prefer_success(e) ilu_full_prefer_success(e,__FILE__,__LINE__)

// callable by C++
ilu_cardinal ilu_scheme_lang_idx();
void ilu_full_prefer_success(ilu_Error* e, const char* atf, unsigned int atl);
ilu_Object ilu_input_object_id(ilu_SCMCall, ilu_boolean, ilu_Class);
SCM ilu_get_language_specific_object(ilu_Object obj);
ilu_Server ilu_get_object_server(ilu_Object obj);
ilu_boolean ilu_output_object_id(ilu_SCMCall,ilu_Object,ilu_boolean,ilu_Class);
ilu_cardinal ilu_size_of_object_id(ilu_SCMCall,ilu_Object,ilu_boolean,ilu_Class);
void ilu_exit_server(ilu_Server, ilu_Class);
ilu_RcvReqStat ilu_receive_request(ilu_Connection, ilu_SCMCall, ilu_boolean*,
				   ilu_Class*, ilu_Method*, ilu_cardinal*);
ilu_Port ilu_create_port(ilu_Server, ilu_string, ilu_TransportInfo);
ilu_Connection ilu_handle_new_connection(ilu_Port port);

// scheme stubs
SCM ilu__scheme_lang_idx();
SCM ilu__full_prefer_success(SCM _e, SCM _atf, SCM _atl);
SCM ilu__enter_ot_mu();
SCM ilu__exit_ot_mu();
SCM ilu__object_type_defined(SCM _t);
SCM ilu__define_exception(SCM _i, SCM _e);
SCM ilu__define_object_type(SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM);
SCM ilu__define_method(SCM, SCM, SCM, SCM, SCM, SCM, SCM, SCM);
SCM ilu__start_call(SCM _call, SCM _s, SCM _intro_type, SCM _method);
SCM ilu__begin_sizing_exception(SCM _call, SCM _eIndex);
SCM ilu__begin_exception(SCM _call, SCM _eIndex, SCM _argSize);
SCM ilu__start_request(SCM _call, SCM _argSize);
SCM ilu__begin_sizing_reply(SCM _call, SCM _exns_possible);
SCM ilu__begin_reply(SCM _call, SCM _exceptions, SCM _argSize);
SCM ilu__end_sequence(SCM _call);
SCM ilu__end_union(SCM _call);
SCM ilu__end_record(SCM _call);
SCM ilu__end_array(SCM _call);
SCM ilu__exception_of_method(SCM _method, SCM _index);
SCM ilu__exception_count_of_method(SCM _m);
SCM ilu__get_object_class(SCM _obj);
SCM ilu__get_object_server(SCM _obj);
SCM ilu__reply_read(SCM _call);
SCM ilu__finish_call(SCM _call);
SCM ilu__finish_exception(SCM _call);
SCM ilu__finish_request(SCM _call);
SCM ilu__finish_reply(SCM _call);
SCM ilu__no_reply(SCM _call);
SCM ilu__finish_parameters(SCM _call, SCM _obj);
SCM ilu__input_byte(SCM _call);
SCM ilu__input_boolean(SCM _call);
SCM ilu__input_optional(SCM _call);
SCM ilu__input_cardinal(SCM _call);
SCM ilu__input_character(SCM _call);
SCM ilu__input_enum(SCM _call);
SCM ilu__input_integer(SCM _call);
SCM ilu__input_real(SCM _call);
SCM ilu__input_short_cardinal(SCM _call);
SCM ilu__input_short_integer(SCM _call);
SCM ilu__input_short_real(SCM _call);
SCM ilu__input_long_cardinal(SCM _call);
SCM ilu__input_long_integer(SCM _call);
SCM ilu__input_long_real(SCM _call);
SCM ilu__input_bytes(SCM _call, SCM _limit);
SCM ilu__input_opaque(SCM _call, SCM _limit);
SCM ilu__input_string(SCM _call, SCM _limit);
SCM ilu__input_string_vec(SCM _call, SCM _len);
SCM ilu__input_w_string(SCM _call, SCM _limit);
SCM ilu__input_w_string_vec(SCM _call, SCM _len);
SCM ilu__input_object_id(SCM _call, SCM _discriminator_p, SCM _putative_class);
SCM ilu__input_sequence(SCM _call, SCM _limit);
SCM ilu__input_union(SCM _call, SCM _limit);
SCM ilu__input_record(SCM _call);
SCM ilu__input_array(SCM _call);
SCM ilu__enter_server(SCM _ks, SCM _c);
SCM ilu__exit_server(SCM _ks, SCM _c);
SCM ilu__sbh_to_object(SCM _sbh, SCM _c);
SCM ilu__sbh_of_object(SCM _obj);
SCM ilu__output_byte(SCM _call, SCM _byte);
SCM ilu__output_boolean(SCM _call, SCM _b);
SCM ilu__output_optional(SCM _call, SCM _b);
SCM ilu__output_cardinal(SCM _call, SCM _v);
SCM ilu__output_character(SCM _call, SCM _v);
SCM ilu__output_enum(SCM _call, SCM _v);
SCM ilu__output_integer(SCM _call, SCM _v);
SCM ilu__output_real(SCM _call, SCM _v);
SCM ilu__output_short_integer(SCM _call, SCM _v);
SCM ilu__output_short_real(SCM _call, SCM _v);
SCM ilu__output_long_cardinal(SCM _call, SCM _v);
SCM ilu__output_long_integer(SCM _call, SCM _v);
SCM ilu__output_long_real(SCM _call, SCM _v);
SCM ilu__output_bytes(SCM _call, SCM _buff, SCM _len, SCM _limit);
SCM ilu__output_opaque(SCM _call, SCM _buff, SCM _len);
SCM ilu__output_string(SCM _call, SCM _buff, SCM _len, SCM _limit);
SCM ilu__output_string_vec(SCM _call, SCM _buff, SCM _len);
SCM ilu__output_w_string(SCM _call, SCM _buf, SCM _len, SCM _limit);
SCM ilu__output_w_string_vec(SCM _call, SCM _buf, SCM _len);
SCM ilu__output_object_id(SCM _call, SCM _obj, SCM, SCM);
SCM ilu__output_sequence(SCM _call, SCM _length, SCM _limit);
SCM ilu__output_union(SCM _call, SCM _discriminator, SCM _discriminator_size);
SCM ilu__output_array(SCM _call);
SCM ilu__output_record(SCM _call);
SCM ilu__size_of_byte(SCM _call, SCM _byte);
SCM ilu__size_of_boolean(SCM _call, SCM _b);
SCM ilu__size_of_optional(SCM _call, SCM _opt);
SCM ilu__size_of_cardinal(SCM _call, SCM _val);
SCM ilu__size_of_character(SCM _call, SCM _val);
SCM ilu__size_of_enum(SCM _call, SCM _val);
SCM ilu__size_of_integer(SCM _call, SCM _val);
SCM ilu__size_of_real(SCM _call, SCM _val);
SCM ilu__size_of_short_cardinal(SCM _call, SCM _val);
SCM ilu__size_of_short_integer(SCM _call, SCM _val);
SCM ilu__size_of_short_real(SCM _call, SCM _val);
SCM ilu__size_of_long_cardinal(SCM _call, SCM _val);
SCM ilu__size_of_long_integer(SCM _call, SCM _val);
SCM ilu__size_of_long_real(SCM _call, SCM _val);
SCM ilu__size_of_bytes(SCM _call, SCM _buf, SCM _len, SCM _limit);
SCM ilu__size_of_opaque(SCM _call, SCM _buf, SCM _len);
SCM ilu__size_of_string(SCM _call, SCM _buf, SCM _len, SCM _limit);
SCM ilu__size_of_string_vec(SCM _call, SCM _buf, SCM _len);
SCM ilu__size_of_w_string(SCM _call, SCM _buf, SCM _len, SCM _limit);
SCM ilu__size_of_w_string_vec(SCM _call, SCM _buf, SCM _len);
SCM ilu__size_of_object_id(SCM call, SCM obj, SCM, SCM);
SCM ilu__size_of_sequence(SCM _call, SCM _len, SCM _limit);
SCM ilu__size_of_union(SCM _call, SCM _discriminator, SCM _discriminator_size);
SCM ilu__size_of_array(SCM _call);
SCM ilu__size_of_record(SCM _call);
SCM ilu__wait_for_reply(SCM _call);
SCM ilu__set_default_server(SCM _s);
SCM ilu__get_default_server();
SCM ilu__create_port(SCM _server, SCM _protocolType, SCM _transportType);
SCM ilu__set_server_default_port(SCM _s, SCM _p);
SCM ilu__parse_sbh(SCM _sbh);
SCM ilu__receive_request(SCM _conn);
SCM ilu__handle_new_connection(SCM _port);
SCM ilu__close_connection(SCM _conn);
SCM ilu__wait_for_port_connection_request(SCM _p);
SCM ilu__create_true_kernel_object(SCM _ih, SCM _server, SCM _c, SCM _lspo);
SCM ilu__find_class_from_type_name(SCM type_name);
SCM ilu__find_class_from_id(SCM _id);
SCM ilu__get_language_specific_object(SCM _obj);
SCM ilu__set_language_specific_object(SCM _obj, SCM _lspo);
SCM ilu__run_main_loop(SCM stop);
SCM ilu__exit_main_loop(SCM stop);
SCM ilu__register_input_handler(SCM _fd, SCM _handlerProc);
SCM ilu__unregister_input_handler(SCM _fd);
SCM ilu__register_output_handler(SCM _fd, SCM _handlerProc);
SCM ilu__unregister_output_handler(SCM _fd);
SCM ilu__publish_object(SCM _obj);
SCM ilu__withdraw_object(SCM _obj, SCM _proof);
SCM ilu__server_of_object(SCM _obj);
SCM ilu__set_main_loop(SCM ml);
SCM ilu__create_alarm();
SCM ilu__set_alarm(SCM _alarm, SCM _time, SCM _proc);
SCM ilu__clear_alarm(SCM _alarm);
SCM ilu__time_now();
SCM ilu__err_nok(SCM _err);
SCM ilu__set_method_stub_proc(SCM _m, SCM _proc);
SCM ilu__get_gc_callback_class();
SCM ilu_call__create();
SCM ilu_call__destroy(SCM _call);
SCM ilu_call__caller(SCM _call);
SCM ilu_call__protocol_exception(SCM _call);
SCM ilu_call__error(SCM _call);
SCM ilu_call__method_of_call(SCM _call);
SCM ilu_class__method(SCM _c, SCM _num);
SCM ilu_class__name(SCM _c);
SCM ilu_class__unique_id(SCM _c);
SCM ilu_server__add_port(SCM _server, SCM _prot, SCM _trans, SCM _default);
SCM ilu_server__create(SCM _name, SCM _objtab);

#endif
