/* context.h */
/* Chris Jacobi, January 31, 1997 5:22 pm PST */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: context.h,v 1.8 1997/02/01 01:37:03 jacobi Exp $ */


typedef struct context_s {
  char* islIfName;   	/* raw name of isl interface */
  char* prefix; 	/* raw name of java prefix-package */	
  char* dirName;	/* name of directory for root of generated stubs */
  boolean flatDir;
  boolean visiHlp;	/* use visigenix style helper class. */
  boolean sunHld;	/* use named holder classes */
  boolean noServer;	/* prevent generation of server side */
  boolean useDel;	/* generate delegation class */
  char* stubSuffix;	/* suffix to designate stub class */
  char* refSuffix;	/* suffix to designate reference interfaces */
  char* holderSuffix;	/* suffix to designate sun style holder classes */
  char* helperSuffix;	/* suffix to designate visigenix style helper classes */
  char* delClassSuffix;	/* suffix to designate delegation class */
} * IHandle;

extern IHandle newContext();
extern void setDefaultContext(IHandle ctx);

extern IHandle getContext(Interface ifc);
extern void setContext(Interface ifc, IHandle ctx);

extern void setContextN(char* name, IHandle ctx);
extern IHandle getContextN(char* name);
    /*gets context for raw islIfName*/

extern IHandle getContextT(Type t);
    /*gets context of interface where type is dclared*/

/* end */
