/* util.h */
/* Chris Jacobi, January 30, 1997 1:52 pm PST */

/*
 * Copyright (c) 1991-1996 Xerox Corporation.  All Rights Reserved.
 * Unlimited use, reproduction, and distribution of this software is permitted.
 * Any copy of this software must include both the above copyright notice of
 * Xerox Corporation and this paragraph.  Any distribution of this software
 * must comply with all applicable United States export control laws.  This
 * software is made available AS IS, and XEROX CORPORATION DISCLAIMS ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND
 * NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY LIABILITY FOR
 * DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED,
 * WHETHER ARISING IN CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT
 * LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES.
 */
 
/* $Id: util.h,v 1.28 1997/01/30 22:28:33 jacobi Exp $ */


typedef iluparser_EnumProc	EnumProc;

extern char * programName;
extern Interface currentIfc;
extern boolean generatingSkeleton;

extern char * booleanImage(int value);
extern TypeDescription	baseTypeDescription(Type t);

extern char * sol;
extern void indent(int levelDelta);
extern void newline(void);

extern void printBanner(const char *part, Interface ifc);

extern void printFormalArgList(list args);
extern void printActualParamList(list args);   
extern void printExceptionList(set excps);

extern char * typeInitializer(TypeKind tk);
/* returns a string containing the initializer for a type */ 
    
extern void NewJavaFile(Interface interface, const char * className);
/* Creates a new file. redirects stdout to the file */

extern boolean matchPointer(void *p1, void *p2);
/* This is a iluparser_FindProc for pointer-EQ */
 
extern void printConst(ConstantValue v, Type t);
    /* prints the constant; t is its type (not v->type) */


extern Type myUrType(Type t);
    /* eats usage and aliases and leaves a definition */

extern void printLoopIndent(const unsigned long level);

extern void printDocString(const char* indent, const char* s);
    /* prints a comment with a doc string s; 
     * indent is template for indentation
     */

/* end */
