(require 'debug)
(require 'Fibber)
(require 'Fibber-stubs)

(define pinfo #f)
(define tinfo (vector "sunrpcrm" "tcp_0_0"))
(define do-client #t)
(define mine #f)
(define s #f)
(define sbh #f)

(define (do-call ask d n self status)
  (set-return-code status Fibber:reply-success)
  (let ((ans (Calc ask status d n self)))
    (if (not (equal? (get-return-code status) Fibber:reply-success))
	(debug:print "Fib error" (get-status-value status)))
    ans))

(define (make-Fibber:T-impl ih server)
  (let* ((ourInstanceHandle #f)
	 (ourServer #f)
	 (obj (object-with-ancestors
	       ((Fibber:T (make-Fibber:T)))
	       ((get-instance-handle this) ourInstanceHandle)
	       ((get-server this) ourServer)
	       ((Calc this status d n ask)
		(let ((f1 0) (f2 0) (ans 1))
		  (set-return-code status Fibber:reply-success)
		  (if (>= n 2)
		      (begin
			(debug:print "fib(" d ", " n ", 1)")
			(set! f1 (do-call ask (+ d 1) (- n 1) this status))
			(debug:print "fib(" d ", " n ", 2)")
			(set! f2 (do-call ask (+ d 1) (- n 2) this status))
			(if (or (not f1) (not f2))
			    (set! ans 0)
			    (set! ans (+ f1 f2)))))
		  (debug:print "fib(" d ", " n ") => " ans)
		  ans))
	       )))
    (set! ourInstanceHandle ih)
    (set! ourServer server)
    obj))

(define (export sid)
  (set! s (ilu-server:create sid #f))
  (if (not s)
      (error "Unable to create my ILU server!"))
  (ilu-server:add-port s pinfo tinfo #t)

  (set! mine (make-Fibber:T-impl "it" s))
  (if (not mine)
      (error "Unable to create my ILU object!"))

  (set! sbh (string-binding-handle mine))
  (debug:print "my SBH = " sbh)
  )

(define (main argc argv)
  (let ((progname (car argv)) (n 0))

    (set! argv (cdr argv))

    ;; process arg list
    (do ((i 1 (+ i 1)))
	((>= i argc))
      (cond ((string=? "-p" (car argv))
	     (set! pinfo (cadr argv))
	     (set! argv (cdr argv)))
	    ((string=? "-c" (car argv))
	     (set! do-client #t))
	    ((string=? "-s" (car argv))
	     (set! do-client #f))
	    ((string=? "-t" (car argv))  ;; broken for now
	     (set! tinfo (list->vector (cdr argv))))
	    (#t
	     (set! n (string->number (car argv))))
	     )
      (set! argv (cdr argv)))

    (if do-client
	(let ((peer #f) (ans 0) (i 0) (ss #f) (env (make-Fibber:status)))
	  (export #f)
	  (set! peer (ilu-object:lookup "Fibber-Test-Server" "it" Fibber:T:class-record))
	  (if (not peer) (error "Unable to import peer!"))
	  (set! ans (Calc peer env 1 n mine))
	  (cond ((equal? (get-return-code env) Fibber:reply-success)
		 (debug:print "Fib(" n ") = " ans))
		((equal? (get-return-code env) Fibber:Failed-exception)
		 (set! ss (get-status-value env))
		 (debug:print "Fib(" n ") => Failed " (length ss))
		 (do ((s ss (cdr ss)))
		     ((not s))
		   (debug:print (car s)))
		 (debug:print))
		(#t
		 (debug:print "Fib(" n ") => Failed "
			(get-return-code env) " "
			(get-status-value env))))
	  )
	(begin
	  (export "Fibber-Test-Server")
	  (if (not (publish mine))
	      (error "Can't publish object!"))
	  (debug:print "Serving..")
	  (ilu:run-main-loop 1))
	)
    ))