(require 'debug)
(require 'Test1)
(require 'Test2)
(require 'Test3)

(define (debug:printU prefix varName u)
  (begin
    (debug:print prefix varName ".discriminator =  " (car u))
    (cond ((= 3 (car u))
	   (debug:print varName "value.O1 = 0x" (object-address (cdr u))))
	  ((= 5 (car u))
	   (debug:print varName "value.boolean = " (cdr u)))
	  (#t
	   (debug:print "(unexpected value)"))
	  )
    ))

(define (main argc argv)
  (let ((s1 (make-Test1:status))
	(handle #f) (o2 #f) (o3 #f) (f #f) (u #f)
	(css #f) (scs #f) (ro #f) (r #f))

    (set! handle (ilu-object:lookup "Test1-Server"
				    "Test1_Initial_Object"
				    Test1:TheO1:class-record))

    (if (not handle)
	(error "Unable to import server!"))

    (set! u (cons 5 #t))
    (set! scs (vector "hello world" "hello mars" ""))

    (set! css (Test1:CSS 2 (vector->list scs)))

    (set! u (U-CSS-to-U handle s1 u css))

    (if (get-return-code s1)
	(error "U-CSS-to-U => exn " (get-return-code s1)))

    (debug:printU "" "u" u)

    (set! ro (f-CSS-to-RO handle s1 css))
    (if (get-return-code s1)
	(error "f-CSS-to-RO => exn " (get-return-code s1)))
    (debug:print "ro->i = " (get-i ro))
    (debug:print "ro->css = " (get-css ro))
    (debug:print "ro->a = " (get-a ro))

    (set! f (R-ScS-to-F handle s1 ro (vector-ref scs 0)))
    (if (get-return-code s1)
	(error "R-ScS-to-F => exn " (get-return-code s1)))
    (debug:print "f = " f);

    (a-RO handle s1 ro)

    (if (get-return-code s1)
	(error "a-RO => exn " (get-return-code s1)))

    (set! o2 (get-O2 handle s1))

    (if (equal? (get-return-code s1) Test1:reply-success)
	(begin
	  (let ((a (make-vector 8 #\space))
		(ap #f)
		(a1 #f)
		(i 0)
		(css2 #f))

	    (debug:print "got O2, sbh = " (string-binding-handle o2))

	    (set! css2 (OO-A0-to-CSS o2 s1 handle a))

	    (if (not (eq? (get-return-code s1) Test2:reply-success))
		(debug:print "exception on Test1:O2:OO-A0-to-CSS, exception is "
		       (get-return-code s1)))

	    (set! r (make-Test1:TheR))
	    (set-css r (Test1:CSS 1 (list "xxx")))
	    (set-i r 12)
	    (set-a r (make-vector 3))
	    (vector-set! (get-a r) 0 "this is")
	    (vector-set! (get-a r) 1 "data")
	    (vector-set! (get-a r) 2 "initialization")
	    (set! a1 (vector "but this" "is" "fun"));
	    (set! ap (R-I-A1-to-I-A0 o2 s1 r i a1))
	    (set! i (car ap))
	    (set! ap (cadr ap))
	    ))
	(debug:print "couldn't get an instance of O2.  Exception is "
	       (get-return-code s1))
	)

    (set! o3 (get-O3 handle s1 #f))

    (if (eq? (get-return-code s1) Test1:reply-success)
	(begin
	  (let ((rs (Test1:TheRS 0 #f))
		(i2 #f))

	    (debug:print "got O3, sbh = " (string-binding-handle o3) 
		   ", type = " (class-name o3))

	    (if (not (equal? (get-instance-class-record o3)
			     (ilu:find-class-from-type-name "Test1.O3")))
		(debug:print "instance of class " (class-name o3) " received!")
		(begin
		  (set! i2 (RS-R-to-R-IS o3 s1 rs r))
		  (set! rs (car i2))
		  (set! i2 (cadr i2))
		  (set! u (car (O1-U-to-U o3 s1 handle u)))
		  (debug:printU "" "u" u)
		  )
		)
	    ))
	(debug:print "couldn't get an instance of O3.  Exception is "
	       (get-return-code s1))
	)

    (set! o3 (get-O3 handle s1 #t))

    (if (eq? (get-return-code s1) Test1:reply-success)
	(let ((rs (Test1:TheRS 0 #f))
	      (i2 #f))

	  (debug:print "got O3, sbh = " (string-binding-handle o3)
		 ", type = " (class-name o3))
	  
	  (set! i2 (car (RS-R-to-R-IS o3 s1 rs r)))
	  (set! u (car (O1-U-to-U o3 s1 handle u)))

	  (debug:printU "" "u" u)

	  (if (equal? (get-instance-class-record o3)
		      (ilu:find-class-from-type-name "Test3.O"))
	      (let ((o #f) (s3 (make-Test3:status)) (u2 #f))
		(set! o o3)
		(set! u2 (I-to-Test1U o s3 397))

		(if (not (equal? (get-return-code s3)
			      Test3:reply-success))
		    (debug:print "exception on Test3_O::I_to_Test1U, exception is "
			    (get-return-code s3))
		    (debug:printU "Test3_O::I_to_Test1U:  " "u2" u2))
		)))
	  (debug:print "couldn't get an instance of O3.  Exception is "
		 (get-return-code s1)))

    ;; this next call should return an instance of Test1.O4 
    (set! o3 (get-O3 handle s1 #f))

    (if (equal? (get-return-code s1) Test1:reply-success)
	(begin
	  (debug:print "got O3, sbh = " (string-binding-handle o3)
		 ", type = " (class-name o3))

	  (if (equal? (get-instance-class-record o3)
		      (ilu:find-class-from-type-name "Test1.O4"))
	      (let ((o4 #f) (r1 0.0) (r2 0.0))
		(set! o4 o3)
		(set! r1 12345.6789)
		(set! r2 (R-to-R o4 s1 r1))
		(if (not (equal? (get-return-code s1)
				 Test1:reply-success))
		    (debug:print "exception on R_to_R, exception is "
			    (get-return-code s1))
		    (debug:print "doubles:  r1 is " r1 ", r2 is " r2)))
	      )
	  )
	(debug:print "couldn't get an instance of O3.  Exception is "
	       (get-return-code s1))
	)
    ))
